import type { IncomingMessage } from 'node:http';
import type { Socket } from 'node:net';
import type { DevConfig, Rspack, ServerConfig } from '../types';
import { type DevMiddlewareAPI } from './devMiddleware';
type Options = {
    publicPaths: string[];
    dev: DevConfig;
    server: ServerConfig;
    compiler: Rspack.Compiler | Rspack.MultiCompiler;
};
/**
 * Setup compiler-related logic:
 * 1. setup rsbuild-dev-middleware
 * 2. establish webSocket connect
 */
export declare class CompilerDevMiddleware {
    middleware: DevMiddlewareAPI;
    private devConfig;
    private serverConfig;
    private compiler;
    private publicPaths;
    private socketServer;
    constructor({ dev, server, compiler, publicPaths }: Options);
    init(): Promise<void>;
    upgrade(req: IncomingMessage, sock: Socket, head: any): void;
    close(): void;
    sockWrite(type: string, data?: Record<string, any> | string | boolean): void;
    private setupDevMiddleware;
}
export {};
